<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>scripts.multiple_candidates.mulcan.events &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../" id="documentation_options" src="../../../../_static/documentation_options.js"></script>
        <script src="../../../../_static/jquery.js"></script>
        <script src="../../../../_static/underscore.js"></script>
        <script src="../../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../../_static/doctools.js"></script>
    <script src="../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      <li>scripts.multiple_candidates.mulcan.events</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for scripts.multiple_candidates.mulcan.events</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module to get the events with multiple or single candidates</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">uncertainties</span> <span class="kn">import</span> <span class="n">ufloat</span>


<div class="viewcode-block" id="get_events_with_multiple_candidates"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.events.get_events_with_multiple_candidates">[docs]</a><span class="k">def</span> <span class="nf">get_events_with_multiple_candidates</span><span class="p">(</span>
    <span class="n">series_event_mults</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Get the list of events with multiple candidates (that we&#39;ll call</span>
<span class="sd">    multiple events, for short)</span>

<span class="sd">    Args:</span>
<span class="sd">        series_event_mults : indices are the event numbers,</span>
<span class="sd">            and values are the associated number of candidates.</span>
<span class="sd">            Use the function :py:func:`get_event_multiplicities` to get it.</span>

<span class="sd">    Returns:</span>
<span class="sd">        arrays of event numbers with multiple candidates</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">unique</span><span class="p">(</span><span class="n">series_event_mults</span><span class="p">[(</span><span class="n">series_event_mults</span> <span class="o">&gt;=</span> <span class="mi">2</span><span class="p">)]</span><span class="o">.</span><span class="n">index</span><span class="p">)</span></div>


<div class="viewcode-block" id="get_events_with_given_mult"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.events.get_events_with_given_mult">[docs]</a><span class="k">def</span> <span class="nf">get_events_with_given_mult</span><span class="p">(</span>
    <span class="n">series_event_mults</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">,</span>
    <span class="n">mult</span><span class="p">:</span> <span class="nb">int</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Get the list of events with a given number of candidates</span>

<span class="sd">    Args:</span>
<span class="sd">        series_event_mults : indices are the event numbers,</span>
<span class="sd">            and values are the associated number of candidates.</span>
<span class="sd">            Use the function :py:func:`get_event_multiplicities` to get it.</span>
<span class="sd">        mult: candidate multiplicity</span>

<span class="sd">    Returns:</span>
<span class="sd">        arrays of event numbers with single candidates</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">unique</span><span class="p">(</span><span class="n">series_event_mults</span><span class="p">[(</span><span class="n">series_event_mults</span> <span class="o">==</span> <span class="n">mult</span><span class="p">)]</span><span class="o">.</span><span class="n">index</span><span class="p">)</span></div>


<div class="viewcode-block" id="get_events_with_single_candidates"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.events.get_events_with_single_candidates">[docs]</a><span class="k">def</span> <span class="nf">get_events_with_single_candidates</span><span class="p">(</span>
    <span class="n">series_event_mults</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Get the list of events with only one candidate (that we&#39;ll call</span>
<span class="sd">    single events, for short)</span>

<span class="sd">    Args:</span>
<span class="sd">        series_event_mults : indices are the event numbers,</span>
<span class="sd">            and values are the associated number of candidates.</span>
<span class="sd">            Use the function :py:func:`get_event_multiplicities` to get it.</span>

<span class="sd">    Returns:</span>
<span class="sd">        arrays of event numbers with single candidates</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">get_events_with_given_mult</span><span class="p">(</span><span class="n">series_event_mults</span><span class="p">,</span> <span class="n">mult</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span></div>


<div class="viewcode-block" id="compute_ratio_multiple"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.events.compute_ratio_multiple">[docs]</a><span class="k">def</span> <span class="nf">compute_ratio_multiple</span><span class="p">(</span><span class="n">series_event_mults</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ufloat</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Compute :math:`R_{\\text{R_all}}`, the fraction of events with</span>
<span class="sd">    multiple candidates.</span>

<span class="sd">    Args:</span>
<span class="sd">        series_event_mults: Indices are the event numbers, and values are</span>
<span class="sd">            the associated number of candidates</span>

<span class="sd">    Returns:</span>
<span class="sd">        proportion of events with multiple candidates</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1">#: List of event ids having more than one candidate</span>
    <span class="n">multiple_events</span> <span class="o">=</span> <span class="n">get_events_with_multiple_candidates</span><span class="p">(</span><span class="n">series_event_mults</span><span class="p">)</span>
    <span class="n">single_events</span> <span class="o">=</span> <span class="n">get_events_with_single_candidates</span><span class="p">(</span><span class="n">series_event_mults</span><span class="p">)</span>

    <span class="n">ufloat_nb_multiple_events</span> <span class="o">=</span> <span class="n">ufloat</span><span class="p">(</span>
        <span class="nb">len</span><span class="p">(</span><span class="n">multiple_events</span><span class="p">),</span>
        <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">multiple_events</span><span class="p">))</span>
    <span class="p">)</span>

    <span class="n">ufloat_nb_total_events</span> <span class="o">=</span> <span class="n">ufloat</span><span class="p">(</span>
        <span class="nb">len</span><span class="p">(</span><span class="n">multiple_events</span><span class="p">)</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">single_events</span><span class="p">),</span>
        <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">multiple_events</span><span class="p">)</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">single_events</span><span class="p">))</span>
    <span class="p">)</span>

    <span class="k">return</span> <span class="n">ufloat_nb_multiple_events</span> <span class="o">/</span> <span class="n">ufloat_nb_total_events</span></div>


<div class="viewcode-block" id="get_dataframe_multiple_candidates"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.events.get_dataframe_multiple_candidates">[docs]</a><span class="k">def</span> <span class="nf">get_dataframe_multiple_candidates</span><span class="p">(</span>
    <span class="n">dataframe</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span>
    <span class="n">series_event_mults</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">,</span>
    <span class="n">event_column</span><span class="p">:</span> <span class="nb">str</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Get the dataframe of events with multiple candidates</span>

<span class="sd">    Args:</span>
<span class="sd">        dataframe: sample</span>
<span class="sd">        series_event_mults: Indices are the event numbers, and values are</span>
<span class="sd">            the associated number of candidates</span>
<span class="sd">        event_column: column name used to distinguish one event from another</span>

<span class="sd">    Returns:</span>
<span class="sd">        dataframe of multiple candidates</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">multiple_events</span> <span class="o">=</span> <span class="n">get_events_with_multiple_candidates</span><span class="p">(</span><span class="n">series_event_mults</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">dataframe</span><span class="p">[</span>
        <span class="n">dataframe</span><span class="p">[</span><span class="n">event_column</span><span class="p">]</span><span class="o">.</span><span class="n">isin</span><span class="p">(</span><span class="n">multiple_events</span><span class="p">)</span>
    <span class="p">]</span></div>


<div class="viewcode-block" id="get_dataframe_with_given_mult"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.events.get_dataframe_with_given_mult">[docs]</a><span class="k">def</span> <span class="nf">get_dataframe_with_given_mult</span><span class="p">(</span>
    <span class="n">dataframe</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span>
    <span class="n">series_event_mults</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">,</span>
    <span class="n">event_column</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span>
    <span class="n">mult</span><span class="p">:</span> <span class="nb">int</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Get the dataframe of events with multiple candidates</span>

<span class="sd">    Args:</span>
<span class="sd">        dataframe: sample</span>
<span class="sd">        series_event_mults: Indices are the event numbers, and values are</span>
<span class="sd">            the associated number of candidates</span>
<span class="sd">        event_column: column name used to distinguish one event from another</span>
<span class="sd">        mult: candidatem multiplicity required</span>

<span class="sd">    Returns:</span>
<span class="sd">        dataframe of events with multiplicity ``mult``</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">given_mult_events</span> <span class="o">=</span> <span class="n">get_events_with_given_mult</span><span class="p">(</span>
        <span class="n">series_event_mults</span><span class="p">,</span>
        <span class="n">mult</span>
    <span class="p">)</span>
    <span class="k">return</span> <span class="n">dataframe</span><span class="p">[</span>
        <span class="n">dataframe</span><span class="p">[</span><span class="n">event_column</span><span class="p">]</span><span class="o">.</span><span class="n">isin</span><span class="p">(</span><span class="n">given_mult_events</span><span class="p">)</span>
    <span class="p">]</span></div>


<div class="viewcode-block" id="get_dataframe_single_candidates"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.events.get_dataframe_single_candidates">[docs]</a><span class="k">def</span> <span class="nf">get_dataframe_single_candidates</span><span class="p">(</span>
    <span class="n">dataframe</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span>
    <span class="n">series_event_mults</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">,</span>
    <span class="n">event_column</span><span class="p">:</span> <span class="nb">str</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Get the dataframe of events with multiple candidates</span>

<span class="sd">    Args:</span>
<span class="sd">        dataframe: sample</span>
<span class="sd">        series_event_mults: Indices are the event numbers, and values are</span>
<span class="sd">            the associated number of candidates</span>
<span class="sd">        event_column: column name used to distinguish one event from another</span>

<span class="sd">    Returns:</span>
<span class="sd">        dataframe of multiple candidates</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">get_dataframe_with_given_mult</span><span class="p">(</span>
        <span class="n">dataframe</span><span class="p">,</span> <span class="n">series_event_mults</span><span class="p">,</span> <span class="n">event_column</span><span class="p">,</span> <span class="n">mult</span><span class="o">=</span><span class="mi">1</span>
    <span class="p">)</span></div>


<div class="viewcode-block" id="get_event_multiplicities"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.events.get_event_multiplicities">[docs]</a><span class="k">def</span> <span class="nf">get_event_multiplicities</span><span class="p">(</span>
    <span class="n">dataframe</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span>
    <span class="n">event_column</span><span class="p">:</span> <span class="nb">str</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">    Args:</span>
<span class="sd">        dataframe: data sample, must contain the column ``event_column``</span>
<span class="sd">        event_column: name of the column that allows to identify an event</span>

<span class="sd">    Returns:</span>
<span class="sd">        Indices are the event numbers, and values are the associated</span>
<span class="sd">        number of candidates</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">dataframe</span><span class="o">.</span><span class="n">groupby</span><span class="p">(</span>
        <span class="n">event_column</span>
    <span class="p">)</span><span class="o">.</span><span class="n">size</span><span class="p">()</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>